Subject: RE: combined Option Template Set and Template Set? (was Re: [ipfix-protocol] draft-ietf-ipfix-protocol-09.txt available)

From: "STEPHAN Emile RD-CORE-LAN" <[email-masked]>
Date: Fri, 25 Mar 2005 17:19:55 +0100

Hi Benoit and Sebastian,

We might create a new FieldID named 'ScopeFieldNumber' to avoid the presence of 'Scope Field Count' in a regular template and 'serialize' the scope zone in the regular template:

Regular:

 0                   1                   2                   3  
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
|         FlowSet ID = 0        |       Length = 16 bytes       |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
|               256             |       Field Count = 2         |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
|    8 (sourceIPv4Address)      |       Field Length = 4        |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
|  12 (destinationIPv4Address)  |       Field Length = 4        |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+    

Scoped template (no change in the regular one):

0                   1                   2                   3  
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
|         FlowSet ID = 0        |       Length = 24 bytes       |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
|               257             |       Field Count = 1+1+2     |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
|    ScopeFieldNumber           |       Scope Field Count = 1   |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
|     sourceIPv4NetMask (?)     |     Scope 1 Field Length = 4  |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
|    8 (sourceIPv4Address)      |       Field Length = 4        |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
|  12 (destinationIPv4Address)  |       Field Length = 4        |  
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+    

Regards
Emile

-----Message d'origine-----
De : majordomo listserver [mailto:[email-masked]] De la part de Benoit Claise
Envoyé : vendredi 25 mars 2005 16:23
À : Sebastian Zander
Cc : [email-masked]
Objet : combined Option Template Set and Template Set? (was Re: [ipfix-protocol] draft-ietf-ipfix-protocol-09.txt available)

Dear all, :

> Hi Benoit,
>
>>>>>
>>>>> "There are no constraints regarding the order the Template ID 
>>>>> allocation."
>>>>> ... the order _of_ the ...
>>>>>
>>>>> again, why do we need a separate defintion for template records? 
>>>>> an options
>>>>> template with scope field count = 0 is basically a template record 
>>>>> so the
>>>>> defintion is redundant.
>>>>
>>>>
>>>>
>>>> Option Template has got the notion of scope. Personally I prefer to 
>>>> make a clear distinction.
>>>
>>>
>>>
>>> i think scope it a more general concept. currently it is closely 
>>> tied to
>>> "option data" but the notion of 'option' is very ipfix specific. if 
>>> i'd want
>>> to send data with ipfix that require the use of scope i'd have to 
>>> use option
>>> templates even if my data has nothing to do with 'options'.
>>
>>
>> I thought initially that you wanted combine the Options Template Set 
>> and Template Set into a single Set, which have a scope length of 0 if 
>> appropriate.
>> Now I'm not sure anymore. Practically, what do you suggest?
>>
>
> yeah, my suggestion is to combine both definitions because de-facto the
> template set is already a subset of the option template set (scope 
> length 0).
> the only advantage i see with the current 2 definitions is that you 
> save 2
> bytes in flow templates, which is not very much (especially with SCTP) 
> for
> effectively doubling the spec.
>
> the notion of 'option templates' (the only templates that have scope) 
> is not
> very general.

I would like to ping the rest of the working group regarding this issue.
Should we combine the Option Template Set and Template Set into a single 
Set? 

>
> is the flow keys option template an attempt to introduce scope to flow
> templates? if yes (the current text in section 7.4 is a bit hard to 
> understand
> without having the field defintions) wouldn't it be much simpler to 
> have scope
> for all templates? 

The point is that you only need to send this flow keys option template 
if you want to know the flow keys associated with all the information 
elements in the data record.
Even if you would have a combined Option and Template Set, this would 
not be simplified what you would send:
    - you would still need a template for the data record
    - you would still need a template for the flow key
unless you want to send the flow key in every data record -> this is not 
a good idea!

Regards, Benoit.

--
Help        mailto:[email-masked] and say "help" in message body
Unsubscribe mailto:[email-masked] and say
"unsubscribe ipfix" in message body
Archive     http://ipfix.doit.wisc.edu/archive/

--
Help        mailto:[email-masked] and say "help" in message body
Unsubscribe mailto:[email-masked] and say
"unsubscribe ipfix" in message body
Archive     http://ipfix.doit.wisc.edu/archive/

---

From: Sebastian Zander <[email-masked]>
Date: Sun, 27 Mar 2005 13:12:41 +1000

Hi Emile,

that would work but then the scope count would be required in each
data record (where ScopeFieldNumber is used in the template) right?

cheers,

Sebastian

-- 
Sebastian Zander
http://caia.swin.edu.au